# copyright 1994 Applied Reasoning Systems
# by William R. Burdick Jr.
# You may hack away, as long as you give me credit if you distribute some of this code

# I don't think we can handle raise_lower, because we can't tell whether
# the window used to be on the top or the bottom of the window order

proc float {mode win} { 
    set win [winfo toplevel $win]
    switch $mode {
	up {
	    tkwm restack $win Above None
	}
	down {
	    tkwm restack $win Below None
	}
    }
    register float $mode $win
}

proc restack {win mode sibling} {
    global tkwm_priv floated

    set win [winfo toplevel $win]
    if {[registration $win float] == "up" || [registration $win float] == "down"} {
	return
    }
    if {$mode == "Above" && $sibling == "None" && [set floats [registered float up]] != {}} {
	set sibling [winfo id [lindex $floats 0]]
	set mode Below
    }
    if {$mode == "Below" && $sibling == "None" && [set floats [registered float down]] != {}} {
	set sibling [winfo id [lindex $floats 0]]
	set mode Above
    }
    tkwm restack $win $mode $sibling
}
